/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2005-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	^[QbgVXeɈˑ`iOAKS16-minipj
 */

#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/* 
 *  J[lXe[^X^Cv̒`
 *
 *  L`Lɂ邱ƂŁCOSEKdl̊gG[`FbN𖳌łD
 */
/*#define BASIC_STATUS	*/

/* 
 *  ^[Qbgʃ}N(VXe̒`)
 */
#define OAKS16_MINI

/*
 *  NbZ[W̃^[QbgVXe
 */
#define TARGET_NAME "OAKS16-mini"

/*
 *  ݔԍ̒`
 */
#define	INT_BRKV		0		/* BRK				*/
#define	INT_INT3		4		/* INT3					*/
#define	INT_INT5		8		/* INT5					*/
#define	INT_INT4		9		/* INT4					*/
#define	INT_UART2BCN	10		/* UART2oXՓˌo	*/
#define	INT_DMA0		11		/* DMA0					*/
#define	INT_DMA1		12		/* DMA1					*/
#define	INT_KEY			13		/* L[				*/
#define	INT_AD			14		/* A/Dϊ1				*/
#define	INT_NACK2		15		/* NACK					*/
#define	INT_ACK2		16		/* ACK					*/
#define	INT_UART2TX		15		/* UART2M			*/
#define	INT_UART2RX		16		/* UART2M			*/
#define	INT_UART0TX		17		/* UART0M			*/
#define	INT_UART0RX		18		/* UART0M			*/
#define	INT_UART1TX		19		/* UART1M			*/
#define	INT_UART1RX		20		/* UART1M			*/
#define	INT_TA0			21		/* ^C}A0				*/
#define	INT_TA1			22		/* ^C}A1				*/
#define	INT_TA2			23		/* ^C}A2				*/
#define	INT_TA3			24		/* ^C}A3				*/
#define	INT_TA4			25		/* ^C}A4				*/
#define	INT_TB0			26		/* ^C}B0				*/
#define	INT_TB1			27		/* ^C}B1				*/
#define	INT_TB2			28		/* ^C}B2				*/
#define	INT_INT0		29		/* INT0					*/
#define	INT_INT1		30		/* INT1					*/
#define	INT_UDI			64		/* `			*/
#define	INT_OVF			65		/* I[o[t[		*/
#define	INT_BLKF		66		/* BRK				*/
#define	INT_ADR			67		/* AhXv			*/
#define	INT_SSI			68		/* VOXebv(fobOc[p)			*/
#define	INT_WDT			69		/* Ď^C}/U~ĔUo/dቺo	*/
#define	INT_DBC			70		/* fobOc[p		*/
#define	INT_NMI			71		/* NMI					*/
#define	INT_RESET		72		/* Zbg				*/


#endif /* _SYS_DEFS_H_ */
