/*
 *  Component code for ATK1 Kernel original extension Alarm service
 * 
 *  Copyright (C) 2008-2012 by TOPPERS Project TECS-WG
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 *  
 *  $Id
 *
 */
/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tAlarmSetter_template.c => src/tAlarmSetter.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * alarmTime        uint32_t         ATTR_alarmTime  
 * cycleTime        uint32_t         ATTR_cycleTime  
 *
 * ƤӸؿ #_TCPF_#
 * call port : cAlarm  signature: sAlarm context: task
 *   StatusType     cAlarm_getBase( AlarmBaseRefType p_info );
 *   StatusType     cAlarm_get( TickRefType p_tick );
 *   StatusType     cAlarm_setRelative( TickType incr, TickType cycle );
 *   StatusType     cAlarm_setAbsolute( TickType start, TickType cycle );
 *   StatusType     cAlarm_cancel( );
 *
 * #[</PREAMBLE>]# */

/* ץȥѿ򤳤˽񤭤ޤ #_PAC_# */
#include "tAlarmSetter_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eCyclic
 * entry port: eCyclic
 * signature:  sCyclic
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eCyclic_start
 * name:         eCyclic_start
 * global_name:  tAlarmSetter_eCyclic_start
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eCyclic_start(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

    cAlarm_setRelative(ATTR_alarmTime, ATTR_cycleTime);
}

/* #[<ENTRY_FUNC>]# eCyclic_stop
 * name:         eCyclic_stop
 * global_name:  tAlarmSetter_eCyclic_stop
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eCyclic_stop(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

    cAlarm_cancel();
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
