/*
 * ̃t@C tecsgen ɂ莩܂
 * ̃t@CҏWĎgp邱Ƃ́AӐ}Ă܂
 */
#ifndef tKernel_TECSGEN_H
#define tKernel_TECSGEN_H

/*
 * celltype    :  tKernel
 * global name :  tKernel
 * idx_is_id   :  no
 * singleton   :  yes
 * has_CB      :  false
 * has_INIB    :  true
 * rom         :  yes
 */

/* O[owb_ #_IGH_# */
#include "global_tecsgen.h"

/* VOj`wb_ #_ISH_# */
#include "sKernelTask_tecsgen.h"
#include "sKernelISR1_tecsgen.h"
#include "sKernelISR2_tecsgen.h"
#include "sKernelErrorHook_tecsgen.h"
#include "sKernelTaskHook_tecsgen.h"
#include "sKernelStartupHook_tecsgen.h"
#include "sKernelShutdownHook_tecsgen.h"
#include "sKernelAlarmCallback_tecsgen.h"
#include "sPreKernel_tecsgen.h"
#include "sEventTask_tecsgen.h"
#include "sEventISR2_tecsgen.h"
#include "sEventHook_tecsgen.h"
#include "sHookBody_tecsgen.h"
#include "sStatusTypeHookBody_tecsgen.h"

#ifndef TOPPERS_MACRO_ONLY

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* Z^CvIDX^ #_CTIX_# */
typedef const struct tag_tKernel_INIB *tKernel_IDX;
#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* TOPPERS_MACRO_ONLY */

/* œK̂ߎQƂZ^Cv CB ^̒`捞 #_ICT_# */
#ifndef  TOPPERS_CB_TYPE_ONLY
#define  tKernel_CB_TYPE_ONLY
#define TOPPERS_CB_TYPE_ONLY
#endif  /* TOPPERS_CB_TYPE_ONLY */
#ifdef  tKernel_CB_TYPE_ONLY
#undef TOPPERS_CB_TYPE_ONLY
#endif /* tKernel_CB_TYPE_ONLY */
/* Ăьz̑傫𓾂}N #_NCPA_# */
#define N_CP_cStartupHookBody  (tKernel_SINGLE_CELL_INIB.n_cStartupHookBody)
#define NCP_cStartupHookBody   (tKernel_SINGLE_CELL_INIB.n_cStartupHookBody)
#define N_CP_cShutdownHookBody  (tKernel_SINGLE_CELL_INIB.n_cShutdownHookBody)
#define NCP_cShutdownHookBody   (tKernel_SINGLE_CELL_INIB.n_cShutdownHookBody)
/* optional ĂьeXg}N #_TOCP_# */
#define tKernel_is_cStartupHookBody_joined(p_that,subscript) \
	  ((tKernel_SINGLE_CELL_INIB.cStartupHookBody!=0) \
	  &&(tKernel_SINGLE_CELL_INIB.cStartupHookBody[subscript]!=0))
#define tKernel_is_cErrorHookBody_joined(p_that) \
	  (0)    /* not joined */
#define tKernel_is_cShutdownHookBody_joined(p_that,subscript) \
	  ((tKernel_SINGLE_CELL_INIB.cShutdownHookBody!=0) \
	  &&(tKernel_SINGLE_CELL_INIB.cShutdownHookBody[subscript]!=0))

/* ZCB𓾂}N #_GCB_# */
#define tKernel_GET_CELLCB(idx) ((void *)0)
 /* Ăь֐}N #_CPM_# */
#define tKernel_cStartupHookBody_main( subscript ) \
	  tKernel_SINGLE_CELL_INIB.cStartupHookBody[subscript]->VMT->main__T( \
	  tKernel_SINGLE_CELL_INIB.cStartupHookBody[subscript] )
#define tKernel_cErrorHookBody_main( ercd ) \
	  ((void (*)())0)()
	  /* optional no entry port joined */
#define tKernel_cShutdownHookBody_main( subscript, ercd ) \
	  tKernel_SINGLE_CELL_INIB.cShutdownHookBody[subscript]->VMT->main__T( \
	  tKernel_SINGLE_CELL_INIB.cShutdownHookBody[subscript], (ercd) )

#ifndef TOPPERS_MACRO_ONLY

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
/* Z INIB ^錾 #_CIP_# */
typedef const struct tag_tKernel_INIB {
    /* call port #_TCP_# */ 
    struct tag_sHookBody_VDES **cStartupHookBody;
    int_t n_cStartupHookBody;
    struct tag_sStatusTypeHookBody_VDES **cShutdownHookBody;
    int_t n_cShutdownHookBody;
    /* call port #_NEP_# */ 
}  tKernel_INIB;

/* CB ݂͑ȂBINIB  CB ̑Ɏgp邽߂ define #_DCI_# */
#define tKernel_CB_tab           tKernel_INIB_tab
#define tKernel_SINGLE_CELL_CB   tKernel_SINGLE_CELL_INIB
#define tKernel_CB               tKernel_INIB
#define tag_tKernel_CB           tag_tKernel_INIB

/* VOgZ CB vg^Cv錾 #_SCP_# */
extern  tKernel_INIB  tKernel_SINGLE_CELL_INIB;


/* 󂯌֐vg^Cv錾 #_EPP_# */
/* sKernelTask */
Inline StatusType   tKernel_eKernelTask_schedule();
Inline void         tKernel_eKernelTask_enableAllInterrupts();
Inline void         tKernel_eKernelTask_disableAllInterrupts();
Inline void         tKernel_eKernelTask_resumeAllInterrupts();
Inline void         tKernel_eKernelTask_suspendAllInterrupts();
Inline void         tKernel_eKernelTask_resumeOsInterrupts();
Inline void         tKernel_eKernelTask_suspendOsinterrupts();
Inline AppModeType  tKernel_eKernelTask_getActiveApplicationMode();
Inline StatusType   tKernel_eKernelTask_terminate();
Inline void         tKernel_eKernelTask_shutdownOs( StatusType ercd);
/* sKernelISR1 */
Inline void         tKernel_eKernelISR1_enableAllInterrupts();
Inline void         tKernel_eKernelISR1_disableAllInterrupts();
Inline void         tKernel_eKernelISR1_resumeAllInterrupts();
Inline void         tKernel_eKernelISR1_suspendAllInterrupts();
Inline void         tKernel_eKernelISR1_resumeOsInterrupts();
Inline void         tKernel_eKernelISR1_suspendOsinterrupts();
/* sKernelISR2 */
Inline void         tKernel_eKernelISR2_enableAllInterrupts();
Inline void         tKernel_eKernelISR2_disableAllInterrupts();
Inline void         tKernel_eKernelISR2_resumeAllInterrupts();
Inline void         tKernel_eKernelISR2_suspendAllInterrupts();
Inline void         tKernel_eKernelISR2_resumeOsInterrupts();
Inline void         tKernel_eKernelISR2_suspendOsinterrupts();
Inline AppModeType  tKernel_eKernelISR2_getActiveApplicationMode();
Inline void         tKernel_eKernelISR2_shutdownOs( StatusType ercd);
/* sKernelErrorHook */
Inline void         tKernel_eKernelErrorHook_resumeAllInterrupts();
Inline void         tKernel_eKernelErrorHook_suspendAllInterrupts();
Inline AppModeType  tKernel_eKernelErrorHook_getActiveApplicationMode();
Inline void         tKernel_eKernelErrorHook_shutdownOs( StatusType ercd);
/* sKernelTaskHook */
Inline void         tKernel_eKernelTaskHook_resumeAllInterrupts();
Inline void         tKernel_eKernelTaskHook_suspendAllInterrupts();
Inline AppModeType  tKernel_eKernelTaskHook_getActiveApplicationMode();
/* sKernelStartupHook */
Inline AppModeType  tKernel_eKernelStartupHook_getActiveApplicationMode();
Inline void         tKernel_eKernelStartupHook_shutdownOs( StatusType ercd);
/* sKernelShutdownHook */
Inline AppModeType  tKernel_eKernelShutdownHook_getActiveApplicationMode();
/* sKernelAlarmCallback */
Inline void         tKernel_eKernelAlarmCallback_resumeAllInterrupts();
Inline void         tKernel_eKernelAlarmCallback_suspendAllInterrupts();
/* sPreKernel */
Inline void         tKernel_ePreKernel_startOs( AppModeType mode);
/* sEventTask */
Inline StatusType   tKernel_eEventTask_set( TaskType tskid, EventMaskType mask);
Inline StatusType   tKernel_eEventTask_clear( EventMaskType mask);
Inline StatusType   tKernel_eEventTask_get( TaskType tskid, EventMaskRefType p_mask);
Inline StatusType   tKernel_eEventTask_wait( EventMaskType mask);
/* sEventISR2 */
Inline StatusType   tKernel_eEventISR2_set( TaskType tskid, EventMaskType mask);
Inline StatusType   tKernel_eEventISR2_get( TaskType tskid, EventMaskRefType p_mask);
/* sEventHook */
Inline StatusType   tKernel_eEventHook_get( TaskType tskid, EventMaskRefType p_mask);

/* 󂯌XPg֐vg^Cv錾iVMTsvœKɂQƂ́j #_EPSP_# */

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* TOPPERS_MACRO_ONLY */


/* ZCB𓾂}N(Zk`) #_GCBA_# */
#define GET_CELLCB(idx)  tKernel_GET_CELLCB(idx)

/* CELLCB ^(Zk`) #_CCT_# */
#define CELLCB	tKernel_CB

/* Z^CvIDX^(Zk`) #_CTIXA_# */
#define CELLIDX	tKernel_IDX

/* Ăь֐}NiZk`j#_CPMA_# */
#define cStartupHookBody_main( subscript ) \
                      tKernel_cStartupHookBody_main( subscript ) 
#define cErrorHookBody_main( ercd ) \
                      tKernel_cErrorHookBody_main( ercd ) 
#define cShutdownHookBody_main( subscript, ercd ) \
                      tKernel_cShutdownHookBody_main( subscript, ercd ) 

/* optional ĂьeXg}NiZk`j #_TOCPA_# */
#define is_cStartupHookBody_joined(subscript)\
		tKernel_is_cStartupHookBody_joined(p_cellcb,subscript)
#define is_cErrorHookBody_joined()\
		tKernel_is_cErrorHookBody_joined(p_cellcb)
#define is_cShutdownHookBody_joined(subscript)\
		tKernel_is_cShutdownHookBody_joined(p_cellcb,subscript)

/* 󂯌֐}NiZk`j #_EPM_# */
#define eKernelTask_schedule tKernel_eKernelTask_schedule
#define eKernelTask_enableAllInterrupts tKernel_eKernelTask_enableAllInterrupts
#define eKernelTask_disableAllInterrupts tKernel_eKernelTask_disableAllInterrupts
#define eKernelTask_resumeAllInterrupts tKernel_eKernelTask_resumeAllInterrupts
#define eKernelTask_suspendAllInterrupts tKernel_eKernelTask_suspendAllInterrupts
#define eKernelTask_resumeOsInterrupts tKernel_eKernelTask_resumeOsInterrupts
#define eKernelTask_suspendOsinterrupts tKernel_eKernelTask_suspendOsinterrupts
#define eKernelTask_getActiveApplicationMode tKernel_eKernelTask_getActiveApplicationMode
#define eKernelTask_terminate tKernel_eKernelTask_terminate
#define eKernelTask_shutdownOs tKernel_eKernelTask_shutdownOs
#define eKernelISR1_enableAllInterrupts tKernel_eKernelISR1_enableAllInterrupts
#define eKernelISR1_disableAllInterrupts tKernel_eKernelISR1_disableAllInterrupts
#define eKernelISR1_resumeAllInterrupts tKernel_eKernelISR1_resumeAllInterrupts
#define eKernelISR1_suspendAllInterrupts tKernel_eKernelISR1_suspendAllInterrupts
#define eKernelISR1_resumeOsInterrupts tKernel_eKernelISR1_resumeOsInterrupts
#define eKernelISR1_suspendOsinterrupts tKernel_eKernelISR1_suspendOsinterrupts
#define eKernelISR2_enableAllInterrupts tKernel_eKernelISR2_enableAllInterrupts
#define eKernelISR2_disableAllInterrupts tKernel_eKernelISR2_disableAllInterrupts
#define eKernelISR2_resumeAllInterrupts tKernel_eKernelISR2_resumeAllInterrupts
#define eKernelISR2_suspendAllInterrupts tKernel_eKernelISR2_suspendAllInterrupts
#define eKernelISR2_resumeOsInterrupts tKernel_eKernelISR2_resumeOsInterrupts
#define eKernelISR2_suspendOsinterrupts tKernel_eKernelISR2_suspendOsinterrupts
#define eKernelISR2_getActiveApplicationMode tKernel_eKernelISR2_getActiveApplicationMode
#define eKernelISR2_shutdownOs tKernel_eKernelISR2_shutdownOs
#define eKernelErrorHook_resumeAllInterrupts tKernel_eKernelErrorHook_resumeAllInterrupts
#define eKernelErrorHook_suspendAllInterrupts tKernel_eKernelErrorHook_suspendAllInterrupts
#define eKernelErrorHook_getActiveApplicationMode tKernel_eKernelErrorHook_getActiveApplicationMode
#define eKernelErrorHook_shutdownOs tKernel_eKernelErrorHook_shutdownOs
#define eKernelTaskHook_resumeAllInterrupts tKernel_eKernelTaskHook_resumeAllInterrupts
#define eKernelTaskHook_suspendAllInterrupts tKernel_eKernelTaskHook_suspendAllInterrupts
#define eKernelTaskHook_getActiveApplicationMode tKernel_eKernelTaskHook_getActiveApplicationMode
#define eKernelStartupHook_getActiveApplicationMode tKernel_eKernelStartupHook_getActiveApplicationMode
#define eKernelStartupHook_shutdownOs tKernel_eKernelStartupHook_shutdownOs
#define eKernelShutdownHook_getActiveApplicationMode tKernel_eKernelShutdownHook_getActiveApplicationMode
#define eKernelAlarmCallback_resumeAllInterrupts tKernel_eKernelAlarmCallback_resumeAllInterrupts
#define eKernelAlarmCallback_suspendAllInterrupts tKernel_eKernelAlarmCallback_suspendAllInterrupts
#define ePreKernel_startOs tKernel_ePreKernel_startOs
#define eEventTask_set   tKernel_eEventTask_set
#define eEventTask_clear tKernel_eEventTask_clear
#define eEventTask_get   tKernel_eEventTask_get
#define eEventTask_wait  tKernel_eEventTask_wait
#define eEventISR2_set   tKernel_eEventISR2_set
#define eEventISR2_get   tKernel_eEventISR2_get
#define eEventHook_get   tKernel_eEventHook_get

/* CB }N #_CIM_# */
#define INITIALIZE_CB()
#define SET_CB_INIB_POINTER(i,p_that)\
	/* empty */
#ifndef TOPPERS_MACRO_ONLY

/* inline wb_ include #_INL_# */
#include "tKernel_inline.h"

#endif /* TOPPERS_MACRO_ONLY */

#ifdef TOPPERS_CB_TYPE_ONLY

/* inline ̂߂ undef #_UDF_# */
#undef VALID_IDX
#undef GET_CELLCB
#undef CELLCB
#undef CELLIDX
#undef FOREACH_CELL
#undef END_FOREACH_CELL
#undef INITIALIZE_CB
#undef SET_CB_INIB_POINTER
#undef ATTR_name
#undef tKernel_ATTR_name
#undef tKernel_GET_name
#undef ATTR_status
#undef tKernel_ATTR_status
#undef tKernel_GET_status
#undef ATTR_useStartupHook
#undef tKernel_ATTR_useStartupHook
#undef tKernel_GET_useStartupHook
#undef ATTR_useErrorHook
#undef tKernel_ATTR_useErrorHook
#undef tKernel_GET_useErrorHook
#undef ATTR_useShutdownHook
#undef tKernel_ATTR_useShutdownHook
#undef tKernel_GET_useShutdownHook
#undef ATTR_usePreTaskHook
#undef tKernel_ATTR_usePreTaskHook
#undef tKernel_GET_usePreTaskHook
#undef ATTR_usePostTaskHook
#undef tKernel_ATTR_usePostTaskHook
#undef tKernel_GET_usePostTaskHook
#undef ATTR_useGetServiceId
#undef tKernel_ATTR_useGetServiceId
#undef tKernel_GET_useGetServiceId
#undef ATTR_useParameterAccess
#undef tKernel_ATTR_useParameterAccess
#undef tKernel_GET_useParameterAccess
#undef ATTR_useResourceScheduler
#undef tKernel_ATTR_useResourceScheduler
#undef tKernel_GET_useResourceScheduler
#undef tKernel_cStartupHookBody_main
#undef cStartupHookBody_main
#undef tKernel_cErrorHookBody_main
#undef cErrorHookBody_main
#undef tKernel_cShutdownHookBody_main
#undef cShutdownHookBody_main
#undef eKernelTask_schedule
#undef eKernelTask_enableAllInterrupts
#undef eKernelTask_disableAllInterrupts
#undef eKernelTask_resumeAllInterrupts
#undef eKernelTask_suspendAllInterrupts
#undef eKernelTask_resumeOsInterrupts
#undef eKernelTask_suspendOsinterrupts
#undef eKernelTask_getActiveApplicationMode
#undef eKernelTask_terminate
#undef eKernelTask_shutdownOs
#undef eKernelISR1_enableAllInterrupts
#undef eKernelISR1_disableAllInterrupts
#undef eKernelISR1_resumeAllInterrupts
#undef eKernelISR1_suspendAllInterrupts
#undef eKernelISR1_resumeOsInterrupts
#undef eKernelISR1_suspendOsinterrupts
#undef eKernelISR2_enableAllInterrupts
#undef eKernelISR2_disableAllInterrupts
#undef eKernelISR2_resumeAllInterrupts
#undef eKernelISR2_suspendAllInterrupts
#undef eKernelISR2_resumeOsInterrupts
#undef eKernelISR2_suspendOsinterrupts
#undef eKernelISR2_getActiveApplicationMode
#undef eKernelISR2_shutdownOs
#undef eKernelErrorHook_resumeAllInterrupts
#undef eKernelErrorHook_suspendAllInterrupts
#undef eKernelErrorHook_getActiveApplicationMode
#undef eKernelErrorHook_shutdownOs
#undef eKernelTaskHook_resumeAllInterrupts
#undef eKernelTaskHook_suspendAllInterrupts
#undef eKernelTaskHook_getActiveApplicationMode
#undef eKernelStartupHook_getActiveApplicationMode
#undef eKernelStartupHook_shutdownOs
#undef eKernelShutdownHook_getActiveApplicationMode
#undef eKernelAlarmCallback_resumeAllInterrupts
#undef eKernelAlarmCallback_suspendAllInterrupts
#undef ePreKernel_startOs
#undef eEventTask_set
#undef eEventTask_clear
#undef eEventTask_get
#undef eEventTask_wait
#undef eEventISR2_set
#undef eEventISR2_get
#undef eEventHook_get
#endif /* TOPPERS_CB_TYPE_ONLY */

#endif /* tKernel_TECSGEN_H */
