/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2008-2011 by TOPPERS Project
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *  
 *  $Id: tHwSerial.c 1481 2011-06-09 16:37:43Z witz-ukai $
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tHwSerial_template.c => src/tHwSerial.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * intLevelRx       UINT8            ATTR_intLevelRx 
 * baudRate         UINT8            ATTR_baudRate   
 *
 * Ăь֐ #_TCPF_#
 * call port : ciHwSerial  signature: siHwSerial context: task
 *   void           ciHwSerial_receiveChar( UINT8 character );
 *
 * #[</PREAMBLE>]# */

/* vg^Cv錾ϐ̒`ɏ܂ */
#include "tHwSerial_tecsgen.h"

#include "sfrm16c26.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/*
 *	Tv^[QbgˑVAIOW[iOAKS16-minij
 */

/*
 *  KD30 gp( USE_KD30 `) KD30  UART1 gp邽߁C
 *  VAIOW[͓삳ȂD
 *  UART0 gp͂邪COILt@CɋLڂĂ銄݃Gg[
 *  ԍRpCIvV( USE_KD30 )Őؑւ悢@Ȃ߁C
 *  UART0 gp͍sȂD
 */

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eHwSerial
 * entry port: eHwSerial
 * signature:  sHwSerial
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eHwSerial_initialize
 * name:         eHwSerial_initialize
 * global_name:  tHwSerial_eHwSerial_initialize
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eHwSerial_initialize(CELLIDX idx)
{

#if !defined( USE_KD30 )
	/*
	 *  M֎~ĊeWX^ݒ
	 */
	TE_U1C1 = 0;						/* M֎~					*/
	RE_U1C1 = 0;						/* M֎~					*/

	/*
	 *  NbNgp, 񓯊ʐM, 8rbgf[^,
	 *  peBȂ, X[vȂ, NbNf1, CTS/RTS֎~
	 */
	U1MR = (UINT8)0x05;			/* NbN, 񓯊, 8rbg,	*/
								/* peBȂ, X[vȂ		*/
	U1C0 = (UINT8)0x10;			/* NbNf1I, CTS/RTS֎~		*/

	/*
	 *  {[[gݒiݒl̓wb_QƁj
	 */
	U1BRG = ATTR_baudRate;

	/*
	 *  M݃xݒiݒ背x̓wb_QƁj
	 *  S1RIC  bit3 ݗvtOłCɃNAĂD
	 *
	 *  M݂͎gpȂD
	 */
	S1RIC = ATTR_intLevelRx;

	/* VAʐMJn	*/
	RE_U1C1 = 1;						/* M					*/
	TE_U1C1 = 1;						/* M					*/
#endif	/* USE_KD30	*/

}

/* #[<ENTRY_FUNC>]# eHwSerial_terminate
 * name:         eHwSerial_terminate
 * global_name:  tHwSerial_eHwSerial_terminate
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eHwSerial_terminate(CELLIDX idx)
{

#if !defined( USE_KD30 )
	S1RIC = (UINT8)( 0 );				/* M݃}XN			*/
	S1TIC = (UINT8)( 0 );				/* M݃}XN			*/

	TE_U1C1 = 0;						/* M֎~					*/
	RE_U1C1 = 0;						/* M֎~					*/
#endif	/* USE_KD30	*/

}

/* #[<ENTRY_PORT>]# eHandlerBody
 * entry port: eHandlerBody
 * signature:  sHandlerBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eHandlerBody_main
 * name:         eHandlerBody_main
 * global_name:  tHwSerial_eHandlerBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eHandlerBody_main()
{

#if !defined( USE_KD30 )
	UINT16	rx_data;					/* f[^Mobt@		*/

	/*
	 *  I[oh~̂߂܂Ǎ
	 */
	rx_data = U1RB;

	/*
	 *  M̓R[obNs
	 *  G[̓G[AiM֎~邱ƂŃG[tOOFFj
	 */
	if( ( rx_data & (UINT16)0xff00u ) == 0 ){
		ciHwSerial_receiveChar( (UINT8)rx_data );
	}
	else{
		RE_U1C1 = 0;					/* M֎~					*/
		RE_U1C1 = 1;					/* M					*/
	}
#endif	/* USE_KD30	*/

}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
