/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2008-2011 by TOPPERS Project
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *  
 *  $Id: tHwSysTimer.c 1481 2011-06-09 16:37:43Z witz-ukai $
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tHwSysTimer_template.c => src/tHwSysTimer.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * intLevelSystemClock UINT8            ATTR_intLevelSystemClock
 * prescaler        UINT8            ATTR_prescaler  
 * matchCount       UINT8            ATTR_matchCount 
 *
 * Ăь֐ #_TCPF_#
 * call port : cHandlerBody  signature: sHandlerBody context: task
 *   void           cHandlerBody_main( );
 *
 * #[</PREAMBLE>]# */

/* vg^Cv錾ϐ̒`ɏ܂ */
#include "tHwSysTimer_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/*
 *	Tv^[QbgˑVXe^C}W[iOAKS16-minipj
 */

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eHandlerBody
 * entry port: eHandlerBody
 * signature:  sHandlerBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eHandlerBody_main
 * name:         eHandlerBody_main
 * global_name:  tHwSysTimer_eHandlerBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eHandlerBody_main()
{
	cHandlerBody_main();
}

/* #[<ENTRY_PORT>]# eHwSysTimer
 * entry port: eHwSysTimer
 * signature:  sHwSysTimer
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eHwSysTimer_initialize
 * name:         eHwSysTimer_initialize
 * global_name:  tHwSysTimer_eHwSysTimer_initialize
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eHwSysTimer_initialize()
{
	/*
	 *  ^C}~ĊeWX^ݒ
	 */
	TA0S = 0;							/* ^C}JEg~		*/

	/*
	 *  ^C}A0_EJEg, ^C}[h, JEg\[Xf1/32
	 */
	TA0UD = 0;							/* _EJEg			*/
	TA0MR = (UINT8)0x80;	/* ^C}[h, JEg\[Xf1/32	*/

	/*
	 *  n[hEFAdlɂă^C}\[X̃WX^ݒl+1邽,
	 *  WX^ݒl̓VXeNbNɑJEg
	 *  }CiX1lݒ肷.iݒl̓wb_QƁj
	 */
	TA0 = CFG_SYSCLK - (UINT16)(1u);

	/*
	 *  ^C}RyA݃xݒiݒ背x̓wb_QƁj
	 *  TA0IC  bit3 ݗvtOłCɃNAĂD
	 */
	TA0IC = CFG_INTLVL_SYSCLK;

	TA0S = 1;							/* JEgJn				*/
}

/* #[<ENTRY_FUNC>]# eHwSysTimer_terminate
 * name:         eHwSysTimer_terminate
 * global_name:  tHwSysTimer_eHwSysTimer_terminate
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eHwSysTimer_terminate()
{
	TA0S = 0;							/* JEg~				*/
	TA0IC = (UINT8)( 0 );				/* ݃}XN				*/
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
