/*
 *  Component code for ATK1 Kernel Alarm service
 * 
 *  Copyright (C) 2008-2012 by TOPPERS Project TECS-WG
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *  
 *  $Id
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tKernel_inline_template.h => src/tKernel_inline.h
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * id               UINT8            ATTR_id         
 *
 * #[</PREAMBLE>]# */

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eAlarm
 * entry port: eAlarm
 * signature:  sAlarm
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eAlarm_getBase
 * name:         eAlarm_getBase
 * global_name:  tAlarm_eAlarm_getBase
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eAlarm_getBase(CELLIDX idx, AlarmBaseRefType p_info)
{
	CELLCB	*p_cellcb = GET_CELLCB(idx);
	return (GetAlarmBase(ATTR_id-1, p_info));
}

/* #[<ENTRY_FUNC>]# eAlarm_get
 * name:         eAlarm_get
 * global_name:  tAlarm_eAlarm_get
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eAlarm_get(CELLIDX idx, TickRefType p_tick)
{
	CELLCB	*p_cellcb = GET_CELLCB(idx);
	return (GetAlarm(ATTR_id-1, p_tick));
}

/* #[<ENTRY_FUNC>]# eAlarm_setRelative
 * name:         eAlarm_setRelative
 * global_name:  tAlarm_eAlarm_setRelative
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eAlarm_setRelative(CELLIDX idx, TickType incr, TickType cycle)
{
	CELLCB	*p_cellcb = GET_CELLCB(idx);
	return (SetRelAlarm(ATTR_id-1, incr, cycle));
}

/* #[<ENTRY_FUNC>]# eAlarm_setAbsolute
 * name:         eAlarm_setAbsolute
 * global_name:  tAlarm_eAlarm_setAbsolute
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eAlarm_setAbsolute(CELLIDX idx, TickType start, TickType cycle)
{
	CELLCB	*p_cellcb = GET_CELLCB(idx);
	return (SetAbsAlarm(ATTR_id-1, start, cycle));
}

/* #[<ENTRY_FUNC>]# eAlarm_cancel
 * name:         eAlarm_cancel
 * global_name:  tAlarm_eAlarm_cancel
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eAlarm_cancel(CELLIDX idx)
{
	CELLCB	*p_cellcb = GET_CELLCB(idx);
	return (CancelAlarm(ATTR_id-1));
}

/* #[<ENTRY_PORT>]# eAlarmHook
 * entry port: eAlarmHook
 * signature:  sAlarmHook
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eAlarmHook_getBase
 * name:         eAlarmHook_getBase
 * global_name:  tAlarm_eAlarmHook_getBase
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eAlarmHook_getBase(CELLIDX idx, AlarmBaseRefType p_info)
{
	CELLCB	*p_cellcb;
	return (GetAlarmBase(ATTR_id-1, p_info));
}

/* #[<ENTRY_FUNC>]# eAlarmHook_get
 * name:         eAlarmHook_get
 * global_name:  tAlarm_eAlarmHook_get
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eAlarmHook_get(CELLIDX idx, TickRefType p_tick)
{
	CELLCB	*p_cellcb;
	return (GetAlarm(ATTR_id-1, p_tick));
}

