/*
 *  Component code for ATK1 Kernel Core service
 * 
 *  Copyright (C) 2008-2012 by TOPPERS Project TECS-WG
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *  
 *  $Id
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tKernel_inline_template.h => src/tKernel_inline.h
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * #[</PREAMBLE>]# */

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eKernelTask
 * entry port: eKernelTask
 * signature:  sKernelTask
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eKernelTask_schedule
 * name:         eKernelTask_schedule
 * global_name:  tKernel_eKernelTask_schedule
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eKernelTask_schedule()
{
	return (Schedule());
}

/* #[<ENTRY_FUNC>]# eKernelTask_enableAllInterrupts
 * name:         eKernelTask_enableAllInterrupts
 * global_name:  tKernel_eKernelTask_enableAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelTask_enableAllInterrupts()
{
	EnableAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelTask_disableAllInterrupts
 * name:         eKernelTask_disableAllInterrupts
 * global_name:  tKernel_eKernelTask_disableAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelTask_disableAllInterrupts()
{
	DisableAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelTask_resumeAllInterrupts
 * name:         eKernelTask_resumeAllInterrupts
 * global_name:  tKernel_eKernelTask_resumeAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelTask_resumeAllInterrupts()
{
	ResumeAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelTask_suspendAllInterrupts
 * name:         eKernelTask_suspendAllInterrupts
 * global_name:  tKernel_eKernelTask_suspendAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelTask_suspendAllInterrupts()
{
	SuspendAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelTask_resumeOsInterrupts
 * name:         eKernelTask_resumeOsInterrupts
 * global_name:  tKernel_eKernelTask_resumeOsInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelTask_resumeOsInterrupts()
{
	ResumeOSInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelTask_suspendOsinterrupts
 * name:         eKernelTask_suspendOsinterrupts
 * global_name:  tKernel_eKernelTask_suspendOsinterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelTask_suspendOsinterrupts()
{
	SuspendOSInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelTask_getActiveApplicationMode
 * name:         eKernelTask_getActiveApplicationMode
 * global_name:  tKernel_eKernelTask_getActiveApplicationMode
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline AppModeType
eKernelTask_getActiveApplicationMode()
{
	return (GetActiveApplicationMode());
}

/* #[<ENTRY_FUNC>]# eKernelTask_terminate
 * name:         eKernelTask_terminate
 * global_name:  tKernel_eKernelTask_terminate
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eKernelTask_terminate()
{
	return (TerminateTask());
}

/* #[<ENTRY_FUNC>]# eKernelTask_shutdownOs
 * name:         eKernelTask_shutdownOs
 * global_name:  tKernel_eKernelTask_shutdownOs
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelTask_shutdownOs(StatusType ercd)
{
	ShutdownOS(ercd);
}

/* #[<ENTRY_PORT>]# eKernelISR1
 * entry port: eKernelISR1
 * signature:  sKernelISR1
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eKernelISR1_enableAllInterrupts
 * name:         eKernelISR1_enableAllInterrupts
 * global_name:  tKernel_eKernelISR1_enableAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR1_enableAllInterrupts()
{
	EnableAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR1_disableAllInterrupts
 * name:         eKernelISR1_disableAllInterrupts
 * global_name:  tKernel_eKernelISR1_disableAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR1_disableAllInterrupts()
{
	DisableAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR1_resumeAllInterrupts
 * name:         eKernelISR1_resumeAllInterrupts
 * global_name:  tKernel_eKernelISR1_resumeAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR1_resumeAllInterrupts()
{
	ResumeAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR1_suspendAllInterrupts
 * name:         eKernelISR1_suspendAllInterrupts
 * global_name:  tKernel_eKernelISR1_suspendAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR1_suspendAllInterrupts()
{
	SuspendAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR1_resumeOsInterrupts
 * name:         eKernelISR1_resumeOsInterrupts
 * global_name:  tKernel_eKernelISR1_resumeOsInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR1_resumeOsInterrupts()
{
	ResumeOSInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR1_suspendOsinterrupts
 * name:         eKernelISR1_suspendOsinterrupts
 * global_name:  tKernel_eKernelISR1_suspendOsinterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR1_suspendOsinterrupts()
{
	SuspendOSInterrupts();
}

/* #[<ENTRY_PORT>]# eKernelISR2
 * entry port: eKernelISR2
 * signature:  sKernelISR2
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eKernelISR2_enableAllInterrupts
 * name:         eKernelISR2_enableAllInterrupts
 * global_name:  tKernel_eKernelISR2_enableAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR2_enableAllInterrupts()
{
	EnableAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR2_disableAllInterrupts
 * name:         eKernelISR2_disableAllInterrupts
 * global_name:  tKernel_eKernelISR2_disableAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR2_disableAllInterrupts()
{
	DisableAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR2_resumeAllInterrupts
 * name:         eKernelISR2_resumeAllInterrupts
 * global_name:  tKernel_eKernelISR2_resumeAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR2_resumeAllInterrupts()
{
	ResumeAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR2_suspendAllInterrupts
 * name:         eKernelISR2_suspendAllInterrupts
 * global_name:  tKernel_eKernelISR2_suspendAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR2_suspendAllInterrupts()
{
	SuspendAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR2_resumeOsInterrupts
 * name:         eKernelISR2_resumeOsInterrupts
 * global_name:  tKernel_eKernelISR2_resumeOsInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR2_resumeOsInterrupts()
{
	ResumeOSInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR2_suspendOsinterrupts
 * name:         eKernelISR2_suspendOsinterrupts
 * global_name:  tKernel_eKernelISR2_suspendOsinterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR2_suspendOsinterrupts()
{
	SuspendOSInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelISR2_getActiveApplicationMode
 * name:         eKernelISR2_getActiveApplicationMode
 * global_name:  tKernel_eKernelISR2_getActiveApplicationMode
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline AppModeType
eKernelISR2_getActiveApplicationMode()
{
	return (GetActiveApplicationMode());
}

/* #[<ENTRY_FUNC>]# eKernelISR2_shutdownOs
 * name:         eKernelISR2_shutdownOs
 * global_name:  tKernel_eKernelISR2_shutdownOs
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelISR2_shutdownOs(StatusType ercd)
{
	ShutdownOS(ercd);
}

/* #[<ENTRY_PORT>]# eKernelErrorHook
 * entry port: eKernelErrorHook
 * signature:  sKernelErrorHook
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eKernelErrorHook_resumeAllInterrupts
 * name:         eKernelErrorHook_resumeAllInterrupts
 * global_name:  tKernel_eKernelErrorHook_resumeAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelErrorHook_resumeAllInterrupts()
{
	ResumeAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelErrorHook_suspendAllInterrupts
 * name:         eKernelErrorHook_suspendAllInterrupts
 * global_name:  tKernel_eKernelErrorHook_suspendAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelErrorHook_suspendAllInterrupts()
{
	SuspendAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelErrorHook_getActiveApplicationMode
 * name:         eKernelErrorHook_getActiveApplicationMode
 * global_name:  tKernel_eKernelErrorHook_getActiveApplicationMode
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline AppModeType
eKernelErrorHook_getActiveApplicationMode()
{
	return (GetActiveApplicationMode());
}

/* #[<ENTRY_FUNC>]# eKernelErrorHook_shutdownOs
 * name:         eKernelErrorHook_shutdownOs
 * global_name:  tKernel_eKernelErrorHook_shutdownOs
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelErrorHook_shutdownOs(StatusType ercd)
{
	ShutdownOS(ercd);
}

/* #[<ENTRY_PORT>]# eKernelTaskHook
 * entry port: eKernelTaskHook
 * signature:  sKernelTaskHook
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eKernelTaskHook_resumeAllInterrupts
 * name:         eKernelTaskHook_resumeAllInterrupts
 * global_name:  tKernel_eKernelTaskHook_resumeAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelTaskHook_resumeAllInterrupts()
{
	ResumeAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelTaskHook_suspendAllInterrupts
 * name:         eKernelTaskHook_suspendAllInterrupts
 * global_name:  tKernel_eKernelTaskHook_suspendAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelTaskHook_suspendAllInterrupts()
{
	SuspendAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelTaskHook_getActiveApplicationMode
 * name:         eKernelTaskHook_getActiveApplicationMode
 * global_name:  tKernel_eKernelTaskHook_getActiveApplicationMode
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline AppModeType
eKernelTaskHook_getActiveApplicationMode()
{
	return (GetActiveApplicationMode());
}

/* #[<ENTRY_PORT>]# eKernelStartupHook
 * entry port: eKernelStartupHook
 * signature:  sKernelStartupHook
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eKernelStartupHook_getActiveApplicationMode
 * name:         eKernelStartupHook_getActiveApplicationMode
 * global_name:  tKernel_eKernelStartupHook_getActiveApplicationMode
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline AppModeType
eKernelStartupHook_getActiveApplicationMode()
{
	return (GetActiveApplicationMode());
}

/* #[<ENTRY_FUNC>]# eKernelStartupHook_shutdownOs
 * name:         eKernelStartupHook_shutdownOs
 * global_name:  tKernel_eKernelStartupHook_shutdownOs
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelStartupHook_shutdownOs(StatusType ercd)
{
	ShutdownOS(ercd);
}

/* #[<ENTRY_PORT>]# eKernelShutdownHook
 * entry port: eKernelShutdownHook
 * signature:  sKernelShutdownHook
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eKernelShutdownHook_getActiveApplicationMode
 * name:         eKernelShutdownHook_getActiveApplicationMode
 * global_name:  tKernel_eKernelShutdownHook_getActiveApplicationMode
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline AppModeType
eKernelShutdownHook_getActiveApplicationMode()
{
	return (GetActiveApplicationMode());
}

/* #[<ENTRY_PORT>]# eKernelAlarmCallback
 * entry port: eKernelAlarmCallback
 * signature:  sKernelAlarmCallback
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eKernelAlarmCallback_resumeAllInterrupts
 * name:         eKernelAlarmCallback_resumeAllInterrupts
 * global_name:  tKernel_eKernelAlarmCallback_resumeAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelAlarmCallback_resumeAllInterrupts()
{
	ResumeAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eKernelAlarmCallback_suspendAllInterrupts
 * name:         eKernelAlarmCallback_suspendAllInterrupts
 * global_name:  tKernel_eKernelAlarmCallback_suspendAllInterrupts
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eKernelAlarmCallback_suspendAllInterrupts()
{
	SuspendAllInterrupts();
}

/* #[<ENTRY_PORT>]# ePreKernel
 * entry port: ePreKernel
 * signature:  sPreKernel
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# ePreKernel_startOs
 * name:         ePreKernel_startOs
 * global_name:  tKernel_ePreKernel_startOs
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
ePreKernel_startOs(AppModeType mode)
{
	StartOS(mode);
}

/* #[<ENTRY_PORT>]# eEventTask
 * entry port: eEventTask
 * signature:  sEventTask
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eEventTask_set
 * name:         eEventTask_set
 * global_name:  tKernel_eEventTask_set
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eEventTask_set(TaskType tskid, EventMaskType mask)
{
	return (SetEvent(tskid, mask));
}

/* #[<ENTRY_FUNC>]# eEventTask_clear
 * name:         eEventTask_clear
 * global_name:  tKernel_eEventTask_clear
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eEventTask_clear(EventMaskType mask)
{
	return (ClearEvent(mask));
}

/* #[<ENTRY_FUNC>]# eEventTask_get
 * name:         eEventTask_get
 * global_name:  tKernel_eEventTask_get
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eEventTask_get(TaskType tskid, EventMaskRefType p_mask)
{
	return (GetEvent(tskid, p_mask));
}

/* #[<ENTRY_FUNC>]# eEventTask_wait
 * name:         eEventTask_wait
 * global_name:  tKernel_eEventTask_wait
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eEventTask_wait(EventMaskType mask)
{
	return (WaitEvent(mask));
}

/* #[<ENTRY_PORT>]# eEventISR2
 * entry port: eEventISR2
 * signature:  sEventISR2
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eEventISR2_set
 * name:         eEventISR2_set
 * global_name:  tKernel_eEventISR2_set
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eEventISR2_set(TaskType tskid, EventMaskType mask)
{
	return (SetEvent(tskid, mask));
}

/* #[<ENTRY_FUNC>]# eEventISR2_get
 * name:         eEventISR2_get
 * global_name:  tKernel_eEventISR2_get
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eEventISR2_get(TaskType tskid, EventMaskRefType p_mask)
{
	return (GetEvent(tskid, p_mask));
}

/* #[<ENTRY_PORT>]# eEventHook
 * entry port: eEventHook
 * signature:  sEventHook
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eEventHook_get
 * name:         eEventHook_get
 * global_name:  tKernel_eEventHook_get
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eEventHook_get(TaskType tskid, EventMaskRefType p_mask)
{
	return (GetEvent(tskid, p_mask));
}

