/*
 *  Component code for ATK1 Kernel Task service
 * 
 *  Copyright (C) 2008-2012 by TOPPERS Project TECS-WG
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *  
 *  $Id
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tKernel_inline_template.h => src/tKernel_inline.h
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * id               UINT8            ATTR_id         
 *
 * #[</PREAMBLE>]# */

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eTask
 * entry port: eTask
 * signature:  sTask
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTask_activate
 * name:         eTask_activate
 * global_name:  tTask_eTask_activate
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTask_activate(CELLIDX idx)
{
	CELLCB	*p_cellcb = GET_CELLCB(idx);
	return (ActivateTask(*ATTR_idx));
}

/* #[<ENTRY_FUNC>]# eTask_chain
 * name:         eTask_chain
 * global_name:  tTask_eTask_chain
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTask_chain(CELLIDX idx)
//eTask_chain(CELLIDX idx, TaskType tskid)
{
	CELLCB	*p_cellcb = GET_CELLCB(idx);
	return (ChainTask(*ATTR_idx));
}

/* #[<ENTRY_FUNC>]# eTask_getId
 * name:         eTask_getId
 * global_name:  tTask_eTask_getId
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTask_getId(CELLIDX idx, TaskRefType p_tskid)
{
	CELLCB	*p_cellcb = GET_CELLCB(idx);
	return (GetTaskID(p_tskid));
}

/* #[<ENTRY_FUNC>]# eTask_getState
 * name:         eTask_getState
 * global_name:  tTask_eTask_getState
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTask_getState(CELLIDX idx, TaskStateRefType p_state)
{
	CELLCB	*p_cellcb = GET_CELLCB(idx);
	return (GetTaskState(*ATTR_idx, p_state));
}

/* #[<ENTRY_PORT>]# eTaskISR2
 * entry port: eTaskISR2
 * signature:  sTaskISR2
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTaskISR2_activate
 * name:         eTaskISR2_activate
 * global_name:  tTask_eTaskISR2_activate
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTaskISR2_activate(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	return (ActivateTask(*ATTR_idx));
}

/* #[<ENTRY_FUNC>]# eTaskISR2_getId
 * name:         eTaskISR2_getId
 * global_name:  tTask_eTaskISR2_getId
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTaskISR2_getId(CELLIDX idx, TaskRefType p_tskid)
{
	CELLCB	*p_cellcb;
	return (GetTaskID(p_tskid));
}

/* #[<ENTRY_FUNC>]# eTaskISR2_getState
 * name:         eTaskISR2_getState
 * global_name:  tTask_eTaskISR2_getState
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTaskISR2_getState(CELLIDX idx, TaskStateRefType p_state)
{
	CELLCB	*p_cellcb;
	return (GetTaskState(*ATTR_idx, p_state));
}

/* #[<ENTRY_PORT>]# eTaskHook
 * entry port: eTaskHook
 * signature:  sTaskHook
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTaskHook_getId
 * name:         eTaskHook_getId
 * global_name:  tTask_eTaskHook_getId
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTaskHook_getId(CELLIDX idx, TaskRefType p_tskid)
{
	CELLCB	*p_cellcb;
	return (GetTaskID(p_tskid));
}

/* #[<ENTRY_FUNC>]# eTaskHook_getState
 * name:         eTaskHook_getState
 * global_name:  tTask_eTaskHook_getState
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTaskHook_getState(CELLIDX idx, TaskStateRefType p_state)
{
	CELLCB	*p_cellcb;
	return (GetTaskState(*ATTR_idx, p_state));
}

/* #[<ENTRY_PORT>]# eTaskEvent
 * entry port: eTaskEvent
 * signature:  sTaskEvent
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTaskEvent_set
 * name:         eTaskEvent_set
 * global_name:  tTask_eTaskEvent_set
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTaskEvent_set(CELLIDX idx, EventMaskType mask)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	
	return (SetEvent(*ATTR_idx, mask));
}

/* #[<ENTRY_FUNC>]# eTaskEvent_get
 * name:         eTaskEvent_get
 * global_name:  tTask_eTaskEvent_get
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline StatusType
eTaskEvent_get(CELLIDX idx, EventMaskRefType p_mask)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	
	return (GetEvent(*ATTR_idx, p_mask));
}

